package com.gmail.berndivader.animatorstands.mechanics;

import com.gmail.berndivader.animatorstands.ArmorStandUtils;

import io.lumine.mythic.api.adapters.AbstractEntity;
import io.lumine.mythic.api.config.MythicLineConfig;
import io.lumine.mythic.api.skills.INoTargetSkill;
import io.lumine.mythic.api.skills.ITargetedEntitySkill;
import io.lumine.mythic.api.skills.SkillMetadata;
import io.lumine.mythic.api.skills.SkillResult;
import io.lumine.mythic.bukkit.MythicBukkit;
import io.lumine.mythic.core.mobs.ActiveMob;
import io.lumine.mythic.core.skills.SkillMechanic;

public class ArmorStandInitMechanic extends SkillMechanic implements INoTargetSkill, ITargetedEntitySkill {

	private String animFile;
	private boolean base;
	private Object oi, mobtype;
	private int animSpeed;
	
	public ArmorStandInitMechanic(SkillMechanic skill, MythicLineConfig mlc) {
		super(skill.getManager(),skill.getFile(),mlc.getLine(), mlc);
		this.setAsyncSafe(false);
		this.animFile = mlc.getString(new String[]{"animation","anim","a"},"");
		this.base = mlc.getBoolean(new String[]{"base","plate"},false);
		this.oi = mlc.getBoolean(new String[]{"autoinit","ai"},false);
		this.mobtype = mlc.getString(new String[]{"mobtype"});
		this.animSpeed = mlc.getInteger(new String[]{"speed","animspeed","s"},0);
	}

	@Override
	public SkillResult castAtEntity(SkillMetadata data, AbstractEntity target) {
		if (!MythicBukkit.inst().getMobManager().isActiveMob(target)) return SkillResult.INVALID_TARGET;
		ActiveMob am = MythicBukkit.inst().getMobManager().getMythicMobInstance(target);
		ArmorStandUtils.initArmorStandAnim(am, this.animFile, this.base, this.animSpeed, this.oi, this.mobtype);
		return SkillResult.SUCCESS;
	}

	@Override
	public SkillResult cast(SkillMetadata data) {
		return this.castAtEntity(data, data.getCaster().getEntity());
	}
}
